package com.maintain.business.service;

import com.maintain.business.domain.ErpMaterial;
import com.maintain.business.domain.vo.ErpMaterialVo;
import com.maintain.business.domain.bo.ErpMaterialBo;
import com.maintain.common.core.page.TableDataInfo;
import com.maintain.common.core.domain.PageQuery;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.List;

/**
 * 物资Service接口
 *
 * @author liushuai
 * @date 2025-04-03
 */
public interface IErpMaterialService {

    /**
     * 查询物资
     */
    ErpMaterialVo queryById(Long id);

    /**
     * 查询物资列表
     */
    TableDataInfo<ErpMaterialVo> queryPageList(ErpMaterialBo bo, PageQuery pageQuery);

    /**
     * 查询物资列表
     */
    List<ErpMaterialVo> queryList(ErpMaterialBo bo);

    /**
     * 新增物资
     */
    Boolean insertByBo(ErpMaterialBo bo);

    /**
     * 修改物资
     */
    Boolean updateByBo(ErpMaterialBo bo);

    /**
     * 校验并批量删除物资信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 同步更新物料库存
     * @param id 物料ID
     * @param quantity 数量
     * @param isAdd 增加或减少
     * @return true or false
     */
    boolean modifyMaterialInventory(long id, BigDecimal quantity, boolean isAdd);
}
